#/bin/sh

###########################################################################################
# variable definition
PKG_CONFIG_PATH="/etc/zyxel/zy-pkgs/BackupPlanner/"
ZYSYNCD_CONF_FILE=$PKG_CONFIG_PATH"zysync/zysyncd.conf"
ZYSYNCD_PID_FILE="/var/run/zysyncd.pid"
ZYSYNC_CONF_FOLDER=$PKG_CONFIG_PATH"zysync"
ZYSYNC_MODULE_FILE="/tmp/zysync_modules"
RSYNC_SECRET_FILE="/i-data/.system/rsyncd.secrets"

VOL_INFO_FILE="/tmp/VolInfo"

VOL_NAME=""
MD_PATH=""


###########################################################################################
# main start
if [ ! -d ${ZYSYNC_CONF_FOLDER} ] ; then
	echo "===> Creating \"${ZYSYNC_CONF_FOLDER}\" folder ..."
	mkdir -p ${ZYSYNC_CONF_FOLDER}
fi

				
echo "     ===> Generating volume list ..."
#zyshclient -p 150 -e "storage showIVolumeInfo" > ${VOL_INFO_FILE}

echo "     ===> Generating zysync config file ..."
#zyshclient -p 150 -e "job_controller genZysyncConfig"
echo "########## This file is generated by gen_zysync_sever_config.sh at `date "+%Y/%m/%d %H:%M:%S"` ##########"	 > ${ZYSYNCD_CONF_FILE}
echo "# pid file"								>> ${ZYSYNCD_CONF_FILE}
echo "pid file = ${ZYSYNCD_PID_FILE}"			>> ${ZYSYNCD_CONF_FILE}
echo 											>> ${ZYSYNCD_CONF_FILE}
echo "# secret file"							>> ${ZYSYNCD_CONF_FILE}
echo "secrets file = ${RSYNC_SECRET_FILE}"		>> ${ZYSYNCD_CONF_FILE}
echo 											>> ${ZYSYNCD_CONF_FILE}
echo "# permission"								>> ${ZYSYNCD_CONF_FILE}
echo "incoming chmod = Dugo=rwx,Fugo=rwx"		>> ${ZYSYNCD_CONF_FILE}
echo 											>> ${ZYSYNCD_CONF_FILE}
echo "# charset"								>> ${ZYSYNCD_CONF_FILE}
echo "charset = utf-8"							>> ${ZYSYNCD_CONF_FILE}
echo 											>> ${ZYSYNCD_CONF_FILE}
echo "# available modules list"					>> ${ZYSYNCD_CONF_FILE}

# Only for the still-born project "STG-100", remove it now - 20140212 by andy.
#cat /proc/mdstat | grep "^md"
#if [ "$?" != "0" ]; then
#	VOL_PATH=`echo \`readlink /etc/zyxel/storage/sysvol\``
#	VOL_ID=`echo ${VOL_PATH} | awk -F'/' '{print $3}'`
#	VOL_MAP=`cat /etc/zyxel/storage/*.table | grep ${VOL_ID}`
#	VOL_NAME=`echo ${VOL_MAP} | awk -F'|' '{print $1}'`
#
#	echo "[${VOL_NAME}]"			>> ${ZYSYNCD_CONF_FILE}
#	echo "  path = ${VOL_PATH}"             >> ${ZYSYNCD_CONF_FILE}
#	echo "  auth users = admin"             >> ${ZYSYNCD_CONF_FILE}
#	echo "  read only = no"                 >> ${ZYSYNCD_CONF_FILE}
#
#	exit
#fi

# NOTE: if there's no volume existed in this device, the following "while" loop will be skipped and no available rsync modules can be used in this zysync server
cat /proc/mdstat | grep "^md" | awk '{print $1}' > ${VOL_INFO_FILE}
cat ${VOL_INFO_FILE} | (while read line ; do
	if [ "${line}" = "" ]; then # ignore empty line
		continue
	fi
	
	MD_NAME="`echo ${line} | grep \"^md\"`"
	if [ "${MD_NAME}" = "" ]; then	# ignroe non-mdx name
		continue
	fi
	
	# get md path
	MD_PATH="`cat /proc/mounts | grep -v /home/share | grep -v pkg | grep /i-data/ | grep \"${MD_NAME}\" | awk '{print $2}'`"
	if [ "${MD_PATH}" = "" ]; then	# ignore empty md path
		continue
	fi

	# get md label (volume name)
	if [ ! -f "${MD_PATH}/.media/raid_label" ]; then	# ignore no label volume
		continue
	fi
	
	VOL_NAME="`cat ${MD_PATH}/.media/raid_label`"
	if [ "${VOL_NAME}" = "" ]; then	# ignore empty volume name
		continue
	fi


	## check if module name is duplicated (bz volume name can be duplicated now)
	cat ${ZYSYNC_MODULE_FILE} | grep "${VOL_NAME}" > /dev/null
	if [ "$?" = "0" ]; then	# duplicated
		VOL_NAME="${VOL_NAME}-`echo ${MD_PATH} | awk -F'/' '{print $3}'`"
	fi
	echo "[${VOL_NAME}]"			>> ${ZYSYNCD_CONF_FILE}

	# write to zysyncd config file
	echo "	path = ${MD_PATH}"		>> ${ZYSYNCD_CONF_FILE}
	echo "	auth users = admin"		>> ${ZYSYNCD_CONF_FILE}
	echo "	read only = no"			>> ${ZYSYNCD_CONF_FILE}
	
	# write module name to module list
	echo "${VOL_NAME}"				>> ${ZYSYNC_MODULE_FILE}
done )

# In version 010, we use "share" instead of "volume" as the zysync available modules.
# After discussing with ZyXEL PM (Frank, Kevin), it's rolled back to "volume" since 011 and the following codes are commented out.
# cat /etc/samba/smb.conf | egrep -v "^\[global\]|^\[printers\]"  | grep -A2 "^\[" | (while read line ; do
	# echo "$line" | grep "^\[" > /dev/null
	# if [ "$?" == "0" ]; then
		# SHARE_NAME="`echo "$line" | awk -F'[' '{print $2}' | awk -F']' '{print $1}'`"
		# continue
	# fi

	# echo "$line" | grep "path = " > /dev/null
	# if [ "$?" == "0" ]; then
		# SHARE_PATH="`echo "$line" | awk -F' ' '{print $3}'`"

		# echo "$line" | grep "/etc/zyxel/storage/sysvol/.system/autoshare_sata" > /dev/null
		# if [ "$?" == "0" ]; then
			# SHARE_NAME=""
		# fi
		# continue
	# fi

	# echo "$line" | grep "guest ok = " > /dev/null
	# if [ "$?" == "0" ]; then
		# IS_GUEST="`echo "$line" | awk -F' ' '{print $4}'`"
		# continue
	# fi

	# echo "$line" | grep "valid users = " > /dev/null
	# if [ "$?" == "0" ]; then
		# VALID_USERS="`echo "$line" | awk -F' ' '{print $4}'`"
		# continue
	# fi

	# if [ "$line" == "--" ]; then
		# if [ "${IS_GUEST}" != "yes" ]; then
			# echo ${VALID_USERS} | grep "admin" > /dev/null
			# if [ "$?" != "0" ]; then	# not "guest ok" and owner is not "admin"
				# VALID_USERS=""
				# IS_GUEST=""
				# continue		# -> ignore this share
			# fi
		# fi
		
		# if [ "${SHARE_NAME}" != "" ]; then
			# echo "[$SHARE_NAME]"		>> ${ZYSYNCD_CONF_FILE}
			# echo "	path = $SHARE_PATH"	>> ${ZYSYNCD_CONF_FILE}
			# echo "	auth users = admin"	>> ${ZYSYNCD_CONF_FILE}
			# echo "	read only = no"		>> ${ZYSYNCD_CONF_FILE}
		# fi
		
		# # reset variables
		# VALID_USERS=""
		# IS_GUEST=""
	# fi
# done )


# remove module list file
rm -rf ${ZYSYNC_MODULE_FILE} 
