#/bin/sh

###########################################################################################
# variable definition
PKG_CONFIG_PATH="/etc/zyxel/zy-pkgs/BackupPlanner/"
STUNNELD_PID_FILE="/var/run/stunneld.pid"
STUNNELD_CONF_FILE=$PKG_CONFIG_PATH"stunnel/stunneld.conf"
#STUNNELD_LOG_FILE="/var/log/stunneld.log"
if [ -d /i-data/.system ]; then
	STUNNELD_LOG_FILE="/i-data/.system/stunneld.log"
else
	STUNNELD_LOG_FILE="/i-data/.zyxel/stunneld.log"
fi

STUNNEL_CONF_FOLDER=$PKG_CONFIG_PATH"stunnel"

STUNNELD_ACPT_PORT="9527"
STUNNELD_CONT_PORT="873"

CERT_FILE=$PKG_CONFIG_PATH"zysync/zysync.cert"
KEY_FILE=$PKG_CONFIG_PATH"zysync/zysync.key"

SSL_VER="TLSv1"		# Protocol version (all, SSLv2, SSLv3, TLSv1)
DEBUG_LEVEL="7"


###########################################################################################
# main start
if [ -f ${STUNNELD_PID_FILE} ]; then
	echo "===> stunnel server(`cat ${STUNNELD_PID_FILE}`) exists, please stop it first."
	exit 1
fi

if [ ! -d ${STUNNEL_CONF_FOLDER} ] ; then
	echo "===> Creating \"${STUNNEL_CONF_FOLDER}\" folder ..."
	mkdir -p ${STUNNEL_CONF_FOLDER}
fi

echo "===> Generating stunnel server config file ..."
echo "########## This file is generated by start_stunnel_server.sh ##########"	>  ${STUNNELD_CONF_FILE}
echo "cert = ${CERT_FILE}"							>> ${STUNNELD_CONF_FILE}
echo "key = ${KEY_FILE}"							>> ${STUNNELD_CONF_FILE}
echo "sslVersion = ${SSL_VER}"							>> ${STUNNELD_CONF_FILE}
echo 										>> ${STUNNELD_CONF_FILE}
echo "client = no"								>> ${STUNNELD_CONF_FILE}
echo "pid = ${STUNNELD_PID_FILE}"						>> ${STUNNELD_CONF_FILE}
echo 										>> ${STUNNELD_CONF_FILE}
echo "debug = ${DEBUG_LEVEL}"							>> ${STUNNELD_CONF_FILE}
echo "output = ${STUNNELD_LOG_FILE}"						>> ${STUNNELD_CONF_FILE}
echo 										>> ${STUNNELD_CONF_FILE}
echo "[szysync]"								>> ${STUNNELD_CONF_FILE}
echo "accept = ${STUNNELD_ACPT_PORT}"						>> ${STUNNELD_CONF_FILE}
echo "connect = ${STUNNELD_CONT_PORT}"						>> ${STUNNELD_CONF_FILE}


echo "===> Starting stunnel server ..."
/usr/local/zy-pkgs/bin/stunnel ${STUNNELD_CONF_FILE}

echo "Done"
