#/bin/sh

###########################################################################################
# variable definition
PKG_CONFIG_PATH="/etc/zyxel/zy-pkgs/BackupPlanner/"
ZYSYNCD_PID_FILE="/var/run/zysyncd.pid"
ZYSYNCD_CONF_FILE=$PKG_CONFIG_PATH"zysync/zysyncd.conf"
#ZYSYNCD_LOG_FILE="/var/log/zysyncd.log"
if [ -d /i-data/.system ]; then
	ZYSYNCD_LOG_FILE="/i-data/.system/zysyncd.log"
else
	ZYSYNCD_LOG_FILE="/i-data/.zyxel/zysyncd.log"
fi

ZYSYNC_CONF_FOLDER=$PKG_CONFIG_PATH"zysync"

STUNNELC_PID_FILE="/var/run/stunnelc.pid"

VOL_INFO_FILE="/tmp/VolInfo"

CUR_TYPE=""
CUR_VOL_NAME=""
CUR_MNT_PATH=""


###########################################################################################
# function definition
write_log()
{
	echo "`date "+%Y/%m/%d %H:%M:%S"` [start] $1" >> ${ZYSYNCD_LOG_FILE}
}

reset_vars()
{
	CUR_TYPE=""
	CUR_VOL_NAME=""
	CUR_MNT_PATH=""
}


###########################################################################################
# main start
if [ -f ${ZYSYNCD_PID_FILE} ]; then
	echo "===> zysync server(`cat ${ZYSYNCD_PID_FILE}`) exists, please stop it first."
	write_log "zysync server(`cat ${ZYSYNCD_PID_FILE}`) exists, please stop it first."
	exit 1
fi

if [ -f ${STUNNELC_PID_FILE} ]; then
	echo "===> stunnel client(`cat ${STUNNELC_PID_FILE}`) exists, please stop it first."
	write_log "stunnel client(`cat ${STUNNELC_PID_FILE}`) exists, please stop it first."
	exit 1
fi
                
echo "===> Generate zysync server config ..."
/usr/local/zy-pkgs/bin/gen_zysync_sever_config.sh 

echo "===> Starting zysync server ..."
zysync --daemon --config ${ZYSYNCD_CONF_FILE} --log-file ${ZYSYNCD_LOG_FILE}

echo "Done"
