#/bin/sh

###########################################################################################
# variable definition
PKG_CONFIG_PATH="/etc/zyxel/zy-pkgs/BackupPlanner/"
STUNNELC_PID_FILE="/var/run/stunnelc.pid"
STUNNELC_CONF_FILE=$PKG_CONFIG_PATH"stunnel/stunnelc.conf"


###########################################################################################
# main start
if [ ! -f ${STUNNELC_PID_FILE} ]; then
	echo "===> No stunnel client exists now"
	exit 0
fi
		
#pid="`cat ${STUNNELC_PID_FILE}`"
#echo "===> Stopping stunnel client (${pid}) ..."
echo "===> Stopping stunnel client ..."
#kill ${pid}
#if [ "$?" != "0" ]; then
#	echo "     * Failed! Please check if it's occupied by any other process."
#	exit 1
#fi

# get all stunnel client pids
STUNNEL_CLIENT_PIDS="`ps www | grep "${STUNNELC_CONF_FILE}" | grep -v grep | awk -F' ' '{print $1}'`"
echo "stunnel client pids: ${STUNNEL_CLIENT_PIDS}"

# kill all stunnel client process
kill ${STUNNEL_CLIENT_PIDS}

PID_CHECK="`ps www | grep "${STUNNELC_CONF_FILE}" | grep -v grep | awk -F' ' '{print $1}'`"
i=2
while [ "${PID_CHECK}" != "" ]; do
	if [ $i -eq 6 ]; then
		echo "force kill remaining stunnel client process \"${PID_CHECK}\""
		kill -9 ${PID_CHECK}
		break
	fi

	sleep 1
	echo "-> kill $i time(s) for \"${PID_CHECK}\""
	kill ${PID_CHECK}
	i=$(($i+1))
	PID_CHECK="`ps www | grep "${STUNNELC_CONF_FILE}" | grep -v grep | awk -F' ' '{print $1}'`"
done


## kill others stunnel client if still exists
#i=1
#while [ $i -ne 6 ]; do
#	new_pid=$((${pid} - $i))
#	ps | grep "${new_pid} " | grep -v "grep"
#	if [ "$?" = "0" ]; then
#		echo "killing process (${new_pid}) ..."
#		kill -9 ${new_pid}
#	fi
#	i=$(($i+1))
#done

				
rm -rf ${STUNNELC_PID_FILE}
rm -rf ${STUNNELC_CONF_FILE}
if [ "$?" != "0" ]; then
	echo "     * Failed! Stunnel client has been terminated but we can't delete its config file now."
	exit 1
fi

## - start zysync server
#start_zysync_server.sh
						
echo "Success."
