#/bin/sh

###########################################################################################
# variable definition
PKG_CONFIG_PATH="/etc/zyxel/zy-pkgs/BackupPlanner/"
ZYSYNCD_PID_FILE="/var/run/zysyncd.pid"
ZYSYNCD_CONF_FILE=$PKG_CONFIG_PATH"zysync/zysyncd.conf"
ZYSYNCD_LOG_FILE="/var/log/zysyncd.log"


###########################################################################################
# function definition
write_log()
{
	echo "`date "+%Y/%m/%d %H:%M:%S"` [stop] $1" >> ${ZYSYNCD_LOG_FILE}
}
        

###########################################################################################
# main start
if [ ! -f ${ZYSYNCD_PID_FILE} ]; then
	echo "===> No zysync server exists now"
	write_log "No zysync server exists now"
	exit 0
fi
		
echo "===> Stopping zysync server ..."
kill -9 `cat ${ZYSYNCD_PID_FILE}`
if [ "$?" != "0" ]; then
	echo "     * Failed! Please check if it's occupied by any other process."
	write_log "Stop failed! Please check if it's occupied by any other process."
	exit 1
fi

rm -rf ${ZYSYNCD_PID_FILE}				
rm -rf ${ZYSYNCD_CONF_FILE}
if [ "$?" != "0" ]; then
	echo "     * Failed! Zysync server has been terminated but we can't delete its config file now."
	write_log "Stop failed! Zysync server has been terminated but we can't delete its config file now."
	exit 1
fi

						
write_log "zysync server v2.0.0 has been stopped."
echo "Success."
