﻿/*----Restoring Center---------------------------------------------*/
function queryRestoringJobInfo(data){
	var dataObj = new Object();
	dataObj.progress = data[0]._restoreProgress;
	dataObj.isRunning = data[0]._IsRunning;
	dataObj.jobName = data[0]._jobname;
	dataObj.destination = data[0]._dest;
	return dataObj;
}

function queryRestoringRunTimeByJob(data){
	var obj = new Object();
	obj.backupTime = new Array();

	for(var i=0;i<data.length;i++) {
		obj.backupTime.push(data[i]._time);
	}
	return obj;
}

function queryRestoringFolderByJob(data){
	var obj = {};
	obj.restoredData = new Array();
	for(var i = 0; i < data.length; i++){
		var dataObj = new Object();
		dataObj.name = data[i]._fName;
		dataObj.type = data[i]._type;
		obj.restoredData.push(dataObj);
	}

	return obj;
}

function testRemoteConnection4(data){
	var obj = {};
	obj.testConnectionResult = data[0]._Connected;
	return obj;
}

function mountRemoteShare(data){
	var obj = {};
	obj.mntPath = data[0]._mntPath;

	return obj;
}

function queryRestoringRemoteJobName(data){
	var obj = {};
	obj.jobNameList = new Array();

	for(var i = 0; i < data.length; i++){
		var dataObj = new Object();
		obj.jobNameList[i] = data[i]._jobName;
	}

	return obj;
}

function queryRestoringRemoteRuntime(data){
	var obj = {};
	obj.restoringRunTime = new Array();

	for(var i = 0; i < data.length; i++)
		obj.restoringRunTime.push(data[i]._time);

	return obj;
}

function queryRestoringLocalRuntime(data){

	var obj = {};
	obj.restoringRunTime = new Array();
	for(var i = 0; i < data.length; i++)
		obj.restoringRunTime.push(data[i]._time);

	return obj;
}

function queryRestoringRemoteFolder(data){
	var obj = {};
	obj.restoredData = new Array();

	for(var i = 0; i < data.length; i++){
		var dataObj = new Object();
		dataObj.name = data[i]._fName;
		dataObj.type = data[i]._type;
		obj.restoredData.push(dataObj);
	}

	return obj;
}

function queryRestoringLocalFolder(data){
	var obj = {};
	obj.restoredData = new Array();
	for(var i = 0; i < data.length; i++){
		var dataObj = new Object();
		dataObj.name = data[i]._fName;
		dataObj.type = data[i]._type;
		obj.restoredData.push(dataObj);
	}
	return obj;
}
/*----End of Restoring Center---------------------------------------------*/

/*----Backup-------------------------------------------*/
function backupQueryAll(data){
	var obj = new Object();
	obj.myData = new Array();

	if(!dojo.lang.isEmpty(data[0])){

		for(var i=0;i<data.length;i++) {
			var jobObj = new Object();

			jobObj.jobName = data[i]._Jobname;
			jobObj.jobDescription = data[i]._BackupDescription;
			jobObj.backupMethod = data[i]._BackupMethod;
			jobObj.backupTarget = data[i]._BackupTarget;
			jobObj.bandwidth = data[i]._Bandwidth;
			jobObj.remoteIp = data[i]._RemoteIP;
			jobObj.remoteUserName = data[i]._RemoteAccount;
			jobObj.remotePassword = data[i]._RemotePassword;
			jobObj.sourceVolume = data[i]._SourceVolume;
			jobObj.sourceFolders = data[i]._SourcePath;
			jobObj.targetPath = data[i]._TargetPath;
			jobObj.increNumber = data[i]._IncrementalNumber;
			jobObj.Progress = parseFloat(data[i]._Progress).toFixed(2);;
			jobObj.compressionFlag = data[i]._Compression;
			jobObj.encryptionFlag = data[i]._Encryption;
			jobObj.finalStatus = data[i]._FinalStatus;
			jobObj.encryptionPassword= data[i]._Password;
			jobObj.purgeValue = data[i]._KeepSet;
			jobObj.errMsg = data[i]._FinalStatus;

			obj.myData.push(jobObj);
		}
	}
	return obj;
}

function backupRunSingleJob2(data){
	var dataObj = new Object();
	dataObj.result = data[0]._Result;

	return dataObj;
}

function backupDeleteSingleJob2(data){
	var dataObj = new Object();
	dataObj.result = data[0]._Result;

	return dataObj;
}

function backupAbortSingleJob2(data){
	var dataObj = new Object();
	dataObj.result = data[0]._Result;

	return dataObj;
}

function backupQueryProgress1(data){
	var dataObj = new Object();
	dataObj.progress = data[0]._backupProgress;
	dataObj.isRunning = data[0]._IsRunning;
	return dataObj;
}


function backupQueryRestoreProgress1(data){
	var dataObj = new Object();
	dataObj.percentage = data[0]._restoreProgress;
	dataObj.isRunning = data[0]._IsRunning;
	return dataObj;
}


//backupQuerySyncRemote4
function backupQuerySyncRemote4(data) {
		if(data == ""){
			var obj = {};
			return obj;
		}
        var obj = {remoteFiles: []};

        for (var i = 0; i < data.length; i++) {
                obj.remoteFiles.push({
                        name: data[i]._fName,
                        type: data[i]._type
                });
        }

        return obj;
}


function backupQueryRemoteShare1(data){
	var obj = {};
	obj.shareObj = new Array();
	for(var i = 0; i < data.length; i++){
		var dataObj = new Object();
		dataObj.shareName = data[i]._fName;
		obj.shareObj.push(dataObj);
	}
	return obj;
}
/*----End of Backup---------------------------------------------*/

function schedulerQuerySingleJob1(data){
	var singleJobInfo = new Array();

	singleJobInfo.jobName = data[0]._Jobname;
	singleJobInfo.schId = data[0]._SCH_ID;
	singleJobInfo.jobType = data[0]._JobType;
	singleJobInfo.timeType = data[0]._TimeType;
	singleJobInfo.startTime = data[0]._StartTime;
	singleJobInfo.interval = data[0]._Interval;
	singleJobInfo.DOW = data[0]._DayOfWeek;
	singleJobInfo.DOM = data[0]._DayOfMonth;
	singleJobInfo.MOY = data[0]._MonthOfYear;
	singleJobInfo.jobStatus = data[0]._IsRunning;
	singleJobInfo.lastRunTime = data[0]._LastRunTime;
	singleJobInfo.nextRunTime = data[0]._NextRunTime;
	//singleJobInfo.command = data[0]._Command;

	return singleJobInfo;
}

/*----End of scheduler---------------------------------------------*/